(function ($, Drupal) {
  'use strict';
  Drupal.behaviors.highchartsEditorWidget = {
    attach: function (context, settings) {
      highed.ready(function () {
        const buttons = once('highed-modal-button', '.highed-imp-button', context);

        $(buttons).each(function(i, el) {
          const value = $('#' + $(el).attr('data-target')).val();
          let currentOptions = {};
          let csvData = '';

          if (value.length > 0) {
            currentOptions = JSON.parse(value);
          }

          if (currentOptions.data !== undefined) {
            csvData = currentOptions.data.csv;
          }

          const modal = highed.ModalEditor(el, {
            defaultChartOptions: currentOptions,
            allowDone: true,
            features: 'import templates customize done',
            importer: {
              options: 'plugins csv json'
            }
          }, function (chart) {
            var json = chart.export.json(true);
            $('#' + $(el).attr('data-target')).val(JSON.stringify(json));
          });

          if (csvData.length > 0) {
            modal.editor.dataTable.clear();
            modal.editor.dataTable.loadCSV({csv: csvData});
          }
        });
      });
    }
  }
})(jQuery, Drupal);
